package com.gihon.sso.security;

import org.springframework.beans.factory.InitializingBean;
import org.springframework.security.authentication.AuthenticationProvider;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.core.userdetails.UserDetailsService;

import com.gihon.sso.service.TokenService;

public class GigonAuthenticationProvider implements AuthenticationProvider, InitializingBean {

	private TokenService tokenStore;
	
	@Override
	public void afterPropertiesSet() throws Exception {
		
	}

	@Override
	public Authentication authenticate(Authentication authentication)
			throws AuthenticationException {
		if (!supports(authentication.getClass())) {
            return null;
        }
		Authentication a = tokenStore.getAuthentication(authentication);
		return a;
	}

	@Override
	public boolean supports(Class<?> authentication) {
		return true;
	}
}
