package com.gihon.sso.entity.vo;

import java.io.Serializable;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@Builder
@NoArgsConstructor
@AllArgsConstructor
@Data
@EqualsAndHashCode(of = {"token","refreshToken"})
public class RefreshTokenVal implements Serializable{
	private static final long serialVersionUID = 4983312239078894723L;

	private int moduleType;
	
	private String userAccount;

	private long expireTime;

	private String token;
	
	private String refreshToken;

}
