package com.gihon.common.web.request;

import java.util.Collection;

import com.gihon.common.web.response.PageBean;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 分页查询VO
 * @author baihe
 *
 */
@ApiModel("分页请求")
@Data
public class PageReq {
	@ApiModelProperty("当前页号")
	private int pageIndex;
	@ApiModelProperty("每页大小")
	private int pageSize;
}
